
////////////////////////////////////////////////////////////////////////////////
// 2020.01.22.()
//-----------------------------------------------------------------------------
// ó ; https://github.com/imzcy/cppwebpage
//	Embed an HTML control in your own window using C++. 
//	CPPWebPage is a C++ implementation of CWebPage from codeproject.
//
//=============================================================================
//	cppwebpage  (README.md)
//-----------------------------------------------------------------------------
//	Embed an HTML control in your own window using C++. CPPWebPage is a C++ implementation of CWebPage from codeproject.
//	Original project: http://www.codeproject.com/Articles/3365/Embed-an-HTML-control-in-your-own-window-using-pla
//
////////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "cppwebpage.h"

// A running count of how many windows we have open that contain a browser object
unsigned char WindowCount = 0;

// The class name of our Window to host the browser. It can be anything of your choosing.
static const TCHAR	ClassName[] = L"Browser";

/****************************** WindowProc() ***************************
* Our message handler for our window to host the browser.
*/

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_SIZE:
		{
			// Resize the browser object to fit the window
			ResizeBrowser(hwnd, LOWORD(lParam), HIWORD(lParam));
			return(0);
		}

		case WM_CREATE:
		{
			// Embed the browser object into our host window. We need do this only
			// once. Note that the browser object will start calling some of our
			// IOleInPlaceFrame and IOleClientSite functions as soon as we start
			// calling browser object functions in EmbedBrowserObject().
			if (EmbedBrowserObject(hwnd)) return(-1);

			// Another window created with an embedded browser object
			++WindowCount;

			// Success
			return(0);
		}

		case WM_DESTROY:
		{
			// Detach the browser object from this window, and free resources.
			UnEmbedBrowserObject(hwnd);

			// One less window
			--WindowCount;

			// If all the windows are now closed, quit this app
			if (!WindowCount) PostQuitMessage(0);

			return(TRUE);
		}
	}

	return(DefWindowProc(hwnd, uMsg, wParam, lParam));
}

/****************************** WinMain() ***************************
* C program entry point.
*
* This creates a window to host the web browser, and displays a web
* page.
*/

int CALLBACK WinMain(HINSTANCE hInstance, HINSTANCE hInstNULL, LPSTR lpszCmdLine, int nCmdShow)
{
	MSG	msg;

	// Prepare for QR code recognization
//	wchar_t zcy[] = L"https://secure.imzcy.com/echo/It%20Worked%21";
	wchar_t zcy[] = L"https://www.google.com/";

	// Initialize the OLE interface. We do this once-only.
	if (OleInitialize(NULL) == S_OK)
	{
		WNDCLASSEX		wc;

		// Register the class of our window to host the browser. 'WindowProc' is our message handler
		// and 'ClassName' is the class name. You can choose any class name you want.
		ZeroMemory(&wc, sizeof(WNDCLASSEX));
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.hInstance = hInstance;
		wc.lpfnWndProc = WindowProc;
		wc.lpszClassName = &ClassName[0];
		RegisterClassEx(&wc);

		// Create a window. NOTE: We embed the browser object duing our WM_CREATE handling for
		// this window.
		if ((msg.hwnd = CreateWindowEx(0, &ClassName[0], L"zcy's Website", WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
			HWND_DESKTOP, NULL, hInstance, 0)))
		{
			DisplayHTMLPage(msg.hwnd, zcy);

			// Show the window.
			ShowWindow(msg.hwnd, nCmdShow);
			UpdateWindow(msg.hwnd);
		}

		// Do a message loop until WM_QUIT.
		while (GetMessage(&msg, 0, 0, 0) == 1)
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		// Free the OLE library.
		OleUninitialize();

		return(0);
	}

	MessageBox(0, L"Can't open OLE!", L"ERROR", MB_OK);
	return(-1);
}

